/********************************************************************-*-c-*-*\
*               *  Class examples for Advanced Porgramming                   *
*    #####      *  (!) Giovanni Squillero <giovanni.squillero@polito.it>     *
*   ######      *                                                            *
*   ###   \     *  Copying and distribution of this file, with or without    *
*    ##G  c\    *  modification, are permitted in any medium without royalty *
*    #     _\   *  provided this notice is preserved.                        *
*    |   _/     *  This file is offered as-is, without any warranty.         *
*    |  _/      *                                                            *
*               *  See: http://staff.polito.it/giovanni.squillero/dida.php   *
\****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "stack.h"

STACK *StackInit(int max_dim)
{
    STACK *S;
    S = malloc(sizeof (STACK));
    if(S==NULL)
        return NULL;
    S->vett = malloc(max_dim * sizeof (int));
    if(S->vett==NULL)
        return NULL;

    S->top = -1;
    S->max_dim = max_dim;
    return S;
}

void StackPush(STACK *S, int val)
{
    ++S->top;
    S->vett[S->top] = val;
}

int StackPop(STACK *S)
{
    --S->top;
    return S->vett[S->top+1];
}

int StackEmpty(STACK *S)
{
    return S->top==-1;
}

int StackFull(STACK *S)
{
    return S->top==S->max_dim-1;
}
